<?php
$apiResponseFile = "data/api_responses.txt";
$ids = [];

// Read the API responses file and extract IDs
if (file_exists($apiResponseFile)) {
    $responses = file($apiResponseFile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
    foreach ($responses as $response) {
        $data = json_decode($response, true);
        if ($data && isset($data['id'])) {
            $ids[] = $data['id'];
        }
    }
}

$videoUrl = '';

if (isset($_GET['imageId']) && in_array($_GET['imageId'], $ids)) {
    $selectedId = $_GET['imageId'];
    $host = "https://api.d-id.com/talks/$selectedId";

    $user_name = 'USERNAMEHERE';
    $password = 'PASSWORDSHERE';

    $ch = curl_init($host);
    $headers = [
        'Content-Type: application/json',
        'Authorization: Basic '. base64_encode("$user_name:$password")
    ];
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

    $response = curl_exec($ch);

    if (!curl_errno($ch)) {
        $responseData = json_decode($response, true);
        if (isset($responseData['result_url']) && strpos($responseData['result_url'], '.mp4') !== false) {
            $videoUrl = $responseData['result_url'];
        }
    }

    curl_close($ch);
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Select Image ID</title>
</head>
<body>
    <form action="" method="get">
        <label for="imageId">Select an Image ID:</label>
        <select name="imageId" id="imageId">
            <?php foreach ($ids as $id): ?>
                <option value="<?= htmlspecialchars($id); ?>" <?= (isset($_GET['imageId']) && $_GET['imageId'] === $id) ? 'selected' : ''; ?>>
                    <?= htmlspecialchars($id); ?>
                </option>
            <?php endforeach; ?>
        </select>
        <button type="submit">Submit</button>
    </form>

    <?php if (!empty($videoUrl)): ?>
        <div>
            <p>Result Video:</p>
            <video width="640" height="360" controls>
                <source src="<?= htmlspecialchars($videoUrl); ?>" type="video/mp4">
                Your browser does not support the video tag.
            </video>
        </div>
    <?php endif; ?>
</body>
</html>
