<?php
include_once('esp-database.php'); // Make sure this path is correct

$apiKey = 'OPENA-API CODE; // Replace with your actual API key

// Fetch the last reading from the database
$last_reading = getLastReadings();
$temperature = $last_reading["value1"] . ' °C'; // Adjust according to your database structure
$humidity = $last_reading["value2"] . ' %'; // Adjust according to your database structure

$prompt = "Create a weather report text with lots of humor for a presenter named Noah the Apocalyptic weather presenter. Include information about temperature: $temperature, humidity: $humidity.";

// Setup the cURL request to OpenAI API
$curl = curl_init();
curl_setopt_array($curl, [
    CURLOPT_URL => 'https://api.openai.com/v1/chat/completions',
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_POST => true,
    CURLOPT_POSTFIELDS => json_encode([
        "model" => "gpt-3.5-turbo",
        "messages" => [
            ["role" => "user", "content" => $prompt]
        ]
    ]),
    CURLOPT_HTTPHEADER => [
        'Authorization: Bearer ' . $apiKey,
        'Content-Type: application/json'
    ],
]);

$response = curl_exec($curl);
$error = curl_error($curl);
curl_close($curl);

$description = '';

if (!$error) {
    $responseArray = json_decode($response, true);
    if (isset($responseArray['choices'][0]['message']['content'])) {
        $description = $responseArray['choices'][0]['message']['content'];
    }
}
?>

<!DOCTYPE html>
<html>
<head>
    <title>Image Upload Form</title>
    <style>
        textarea {
            width: 100%;
            min-height: 100px; /* Minimum height to start with */
            max-height: 600px; /* Maximum height before scrolling */
            box-sizing: border-box;
            border: 1px solid #ccc;
            border-radius: 4px;
            font-size: 14px;
            resize: none; /* Disable resizing as JavaScript will handle it */
            padding: 10px; /* Optional: for better text readability */
            overflow-y: hidden; /* Hide the scrollbar until it's needed */
        }
    </style>
</head>
<body>

<h2>Upload Image with Details</h2>

<form action="upload.php" method="post" enctype="multipart/form-data">
    <label for="imageDescription">GPT-IOT text:</label>
    <textarea name="imageDescription" id="imageDescription" required><?php echo htmlspecialchars($description); ?></textarea><br><br>

    <label for="fileToUpload">Select image to upload:</label>
    <input type="file" name="fileToUpload" id="fileToUpload" required><br><br>

    <fieldset>
        <legend>Select Mood:</legend>
        <input type="radio" id="surprise" name="mood" value="surprise">
        <label for="surprise">Surprise</label><br>
        <input type="radio" id="happy" name="mood" value="happy">
        <label for="happy">Happy</label><br>
        <input type="radio" id="serious" name="mood" value="serious">
        <label for="serious">Serious</label><br>
        <input type="radio" id="neutral" name="mood" value="neutral">
        <label for="neutral">Neutral</label>
    </fieldset>
    <br>
    <fieldset>
        <legend>Select Voice:</legend>
        <input type="radio" id="pt-BR-YaraNeural" name="voice" value="pt-BR-YaraNeural">
        <label for="pt-BR-YaraNeural">pt-BR-YaraNeural</label><br>
        <input type="radio" id="pt-BR-BrendaNeural" name="voice" value="pt-BR-BrendaNeural">
        <label for="pt-BR-BrendaNeural">pt-BR-BrendaNeural</label><br>
        <input type="radio" id="en-US-BrandonNeural" name="voice" value="en-US-BrandonNeural">
        <label for="en-US-BrandonNeural">en-US-BrandonNeural</label><br>
        <input type="radio" id="en-US-NancyNeural" name="voice" value="en-US-NancyNeural">
        <label for="en-US-NancyNeural">en-US-NancyNeural</label>
    </fieldset>
    <br>

    <input type="submit" value="Upload Image" name="submit">
</form>

</body>
</html>
